	program histwmap1x1
c .......................................................Apr 2019
C Histogram of monthly & annual Vs=(TEC-TECmed)/STD occurrence 
C                  from 180 glat vs 360 glon trMNDYUTMM.jYR maps
C
c input annual files collected for UT: 0, 1, 2, ...,23 hrs UT
c from IONEX maps
c
	DIMENSION idat(360),icntmn(15),cntyr(15),ctot(15),IM(12)
	+,ITR(14),res(15),syr(15) !*100%
	CHARACTER*64,infile,outfile
	CHARACTER*2 AYR,AMN,ADY,AUT
	CHARACTER*4 AYEAR
	DATA ITR/-350,-300,-250,-200,-150,-100,-50,50,100,150,200
	+,250,300,350/
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C+	iyyyy=1999
	iyyyy=2013
C++	infile='d:\web\del\YR\MN\trMNDYUTMM.jYR'
	infile='d:\web\del\YR\MN\trMNDYUT00.jYR' !Only hourly maps (00 min.)
	outfile='histwmap1x1.txt'
      OPEN(112,FILE=OUTFILE,ACCESS='APPEND')
	write(*,70) (ITR(k),k=1,14)
	write(112,70) (ITR(k),k=1,14)
  70  format(8X,14(3X,I4))
C
	do k=1,15
	ctot(k)=0.
	enddo
C start cycle on Year
 100	iyyyy=iyyyy+1
	do k=1,15
	cntyr(k)=0.
	syr(k)=0.
	enddo

	if (iyyyy.gt.2017) goto 801   ! total result =>
	year=float(iyyyy)
	if(int(year/4.)*4.eq.iyyyy) THEN 
	dnr=366.
	im(2)=29
	if (iyyyy.eq.2000) dnr=352. !-(1:14) Jan.
	                          ELSE
	dnr=365.
	im(2)=28
	ENDIF
C
	cyear=64800.*24.0*dnr
C
	call blet4(iyyyy,AYEAR)
C
	AYR=ayear(3:4)
	infile(12:13)=AYR
	infile(30:31)=AYR
C
C Cycle on MONTH
	DO 171 imn=1,12
	ndays=im(imn)
	nmontot=ndays
	if ((iyyyy.eq.2000).and.(imn.eq.1)) nmontot=17
	call blet2(imn,AMN)
	infile(15:16)=AMN
	infile(20:21)=AMN

	do k=1,15
	icntmn(k)=0
	enddo
C>>	cmon=5112.0*24.0*ndays
       cmon=64800.0*24.0*nmontot
C
200   continue	  !

C Cycle onday-to-day
      ndy1=1
	if ((iyyyy.eq.2000).and.(imn.eq.1)) ndy1=15
	DO 172 idy=ndy1,ndays
	call blet2(idy,ADY)
	infile(22:23)=ADY

C start cycle on UT
	do 201 iut=0,23
	call blet2(iut,AUT)
	infile(24:25)=AUT

C start
C
	OPEN(111,FILE=INFILE)
c     
C  Input datafile 
	do ilat=1,180
c
    1	READ (111,12,END=55,ERR=2) (idat(k),k=1,360)
  12	FORMAT(360(1X,I4))

	DO 202 kt=1,360
	if (idat(kt).lt.itr(1)) then
	icntmn(1)=icntmn(1)+1
	cntyr(1)=cntyr(1)+1.0
	goto 202
	endif
	if (idat(kt).gt.itr(14)) then
	icntmn(15)=icntmn(15)+1
	cntyr(15)=cntyr(15)+1.0
	goto 202
	endif
	if ((idat(kt).ge.itr(7)).and.(idat(kt).le.itr(8))) then
	icntmn(8)=icntmn(8)+1
	cntyr(8)=cntyr(8)+1.0
	goto 202
	endif
	do ii=1,6
	if ((idat(kt).ge.itr(ii)).and.(idat(kt).lt.itr(ii+1))) then
	 icntmn(ii+1)=icntmn(ii+1)+1
	cntyr(ii+1)=cntyr(ii+1)+1.0
	endif
	enddo

	do ii=8,13
	if ((idat(kt).gt.itr(ii)).and.(idat(kt).le.itr(ii+1))) then
	 icntmn(ii+1)=icntmn(ii+1)+1
	cntyr(ii+1)=cntyr(ii+1)+1.0
	endif
	enddo
 202	CONTINUE
	enddo          ! cycle on latitudes
  55   CLOSE(unit=111)

201   CONTINUE       ! Cycle on UT

172   CONTINUE       ! Cycle on day-to-day
	do i=1,15
	syr(i)=syr(i)+float(icntmn(i))
	res(i)=icntmn(i)/cmon*100.    !monthly occurrence %
	enddo
C output monthly results 
   56	write(*,72) ayr,amn,(res(k),k=1,15)
 	 write(112,72) ayr,amn,(res(k),k=1,15)
   72 format(1X,2A2,15(1X,F6.2))

C 
c   
  171 CONTINUE             ! Month-to-month cycle 
C
       sum=0.
	do i=1,15
	ctot(i)=ctot(i)+cntyr(i)
	res(i)=syr(i)/cyear*100.    !annual occurrence %
	sum=sum+cntyr(i)
	enddo
	do i=1,15
	resx=cntyr(i)/cyear*100.
C+		res(i)=cntyr(i)/sum*100.    !annual occurrence %
		resy=cntyr(i)/sum*100.    !annual occurrence %
	enddo
	amn='00'
   	write(*,72) ayr,amn,(res(k),k=1,15)
 	 write(112,72) ayr,amn,(res(k),k=1,15)
	goto 100           !  GO TO NEXT YEAR

  801 continue            ! 
C output annual results for MLAT (all 24 UT bins)
	total=6575.*64800.*24.
	do i=1,15
	res(i)=ctot(i)/total*100.    !average occurrence for 2000-2017%
	enddo
	ayr='XX'
	amn='00'
  802	write(112,72) ayr,amn,(res(k),k=1,15)
 	 write(*,72) ayr,amn,(res(k),k=1,15)
	pause ' '
C
   75 continue	 

	CLOSE(unit=112)
	goto 900
    2 CONTINUE
           write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
  900 pause ' '
      STOP
      END

