      program cormauadg
C...................................................July 2023
C use real-time UADG to correct 1d JPLR prediction 
C
C rat=TECjpl_pre(UT)/TECuadg_pre(UT) for UT =00, 01,...,23 UT (for preceding day)
C
C TECjpl_cur(UT)=TECuadg_cur(UT)*rat for UT =00, 01,...,23 UT (for current day)    
C correct TECjpl_cur map every hour UT during cur_day
C
      DIMENSION IM(12),itecj(0:72),itecu(0:72)  ! for prec day
	+,iteccur(0:72) !uadg : results=> jplr(txMNDDUT.jYR) for current day
	integer*4 IRES(0:72)
      	CHARACTER*4 AYEAR
	CHARACTER*2 AYR
	+,AUT,AMN,ADY,PYR,PMN,PDY
      CHARACTER*40 infile1,infile2,infile3,outfile
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C
C      infile2='d:\web\graf\dta\yr\mn\ut\tcmndyut00.uyr'  ! ionex type map UADG for current day
C
      infile1='d:\web\graf\dta\yr\mn\ut\tcmndyut00.uyr'  ! ionex type map UADG for prec day
C
      infile3='d:\web\graf\dtc\yr\mn\ut\tcmndyut.jyr'  ! ionex type map JPRG for prec day
C
      outfile='d:\web\graf\dtc\yr\mn\ut\txmndyut.jyr'  ! ionex type map JPRG for current day
C
Cnorm        write(*,*) ' Enter AYEAR'
Cnorm	read(*,*) AYEAR
       AYEAR='2023'
	write(*,*) ' year: ',AYEAR
	AYR=AYEAR(3:4)
        write(*,*) ' Enter AMN'
	read(*,*) AMN
        write(*,*) ' Enter ADY'
	read(*,*) ADY
	infile2=infile1
	infile2(17:18)=ayr
 	infile2(20:21)=amn
	infile2(28:29)=amn
	infile2(30:31)=ady
	infile2(38:39)=ayr
C
		outfile(17:18)=ayr
 	outfile(20:21)=amn
	outfile(28:29)=amn
	outfile(30:31)=ady
	outfile(36:37)=ayr

C
    1	CONTINUE		 ! cont for usrg (-1d)
	read(ayear,*) xyear
	IYEAR=int(xyear)
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
C
	read(AMN,*) rmn
	imn=int(rmn)
C
	read(ADY,*) rdy
	idy=int(rdy)
	lda=ndoy(iyr,imn,idy)
	lda_pre=lda-1
C
	z1=iyear/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyear) THEN
               IM(2)=29
	dnr=366.
	ndnr=366
        ELSE
                IM(2)=28
	  	dnr=365.
	ndnr=365
	       ENDIF
C
	jyr_pre=iyr
	jmn_pre=imn
	jdy_pre=idy-1
C NEW YEAR!!!!!!!!!!!!!!!!!!!!!!!!
	if (lda_pre.eq.0) THEN
	lda_pre=366
	jyr_pre=iyr-1
	jmn_pre=12
	jdy_pre=31
	endif
C  END NEW YEAR!!!!!!!!!!!!!!!!!!!!
C NEW MONTH+++++++++++++
      if (jdy_pre.eq.0) then
	jmn_pre=imn-1
	jdy_pre=IM(jmn_pre)
	endif
C END NEW MONTH++++++++++++
      call blet2(jyr_pre,PYR)
      call blet2(jmn_pre,PMN)
	call blet2(jdy_pre,PDY)
	infile1(17:18)=pyr
 	infile1(20:21)=pmn
	infile1(28:29)=pmn
	infile1(30:31)=pdy
	infile1(38:39)=pyr
	infile3(17:18)=pyr
 	infile3(20:21)=pmn
	infile3(28:29)=pmn
	infile3(30:31)=pdy
	infile3(36:37)=pyr
C
 201	CONTINUE		 ! cycle on days
C	AYRI=AYR
   17 format (A2)
C
200   continue	  
C
C read UADG for current day
C
         call subtecut00(AYR,AMN,ADY,iutcur,immcur)  ! read UADG for current day
	if (iutcur.gt.23) iutcur=23
C
C cycle on UT
       DO 181 iut=0,iutcur
	call blet2(iut,AUT)
	infile1(32:33)=AUT
      infile2(32:33)=AUT
      infile3(32:33)=AUT
	outfile(32:33)=AUT 	 
C     infile1='d:\web\graf\dta\yr\mn\ut\tcmndyut00.uyr'  ! ionex type map UADG for prec day
C	infile2='d:\web\graf\dta\yr\mn\ut\tcmndyut00.uyr'  ! ionex type map UADG for current day
C	infile3='d:\web\graf\dtc\yr\mn\ut\tcmndyut.jyr'  ! ionex type map JPRG for prec day

	OPEN(11,file=infile1,action='READ')
	OPEN(12,file=infile2,action='READ')
	OPEN(13,file=infile3,action='READ')
	OPEN(10,file=outfile)
C
C lati cycle
 182	format(73(1X,I4))							
C
        DO 180 ilat=1,71
C
       read(11,182,end=51) (itecu(k),k=0,72)  ! UADG-prec
	read(12,182,end=52) (iteccur(k),k=0,72)  ! UADG-cur
	read(13,182,end=53) (itecj(k),k=0,72)  ! JPLR-pre
C
C Rat=TECjpl/TECupc
	DO k=0,72
	tecupc=itecu(k)/10.
	tecjpl=itecj(k)/10.
	rat=tecjpl/tecupc
	tecnew=iteccur(k)*rat
      ires(k)=nint(tecnew)
	ENDDO
	write(*,182) (ires(k),k=0,72) !OUT of TECjpl corrected hourly maps for cur day
	write(10,182) (ires(k),k=0,72) !OUT of TECjpl corrected hourly maps for cur day
  180	CONTINUE
   51	close(11)
   52	close(12)
   53	close(13)
      close(10)
  181 CONTINUE        ! next UT
       pause ' '
	STOP
	END

