      program devgeo14mm2s
C........................................................Aug.2020
C Reconstruct GIM-TEC in case of absent UQRG
C........................................................Mar. 2022
C Include JPL GIM-TEC correction using UPC GIM-Wmaps
C........................................................Dec. 2021
C TEC median for -15d
C........................................................Oct. 2021
C Add output -15d median
C calculation for -2th day: lda-2
C........................................................May 2021
C
C W(TEC) from UQRG 15min GIM-TEC for 00, 15, 30,45 min 1996-2021
C
C........................................................Jan. 2019
C
C W-index for map in geogr. coords. Glat=-87.5:2.5:87.5, glong=-180:5:180.
C
C........................................................Oct. 2015
C Avoid <a> and <b> extrapolation
C........................................................June 2014
C........................................................Dec. 2013
C results => /graf/
C........................................................Nov.2012
C for JPL hourly data
C........................................................Oct. 2012
C Include subwp3 to update file of Wp index
C........................................................Apr. 2012
C Maps in IONEX format
C
C........................................................Jan. 2012
C Correct transition from month-to-month
C
C  ......................................................Dec.2011
C  Arrange subfur forecast of fcF2, hcF2, tec, Wp maps for two days ahead
C
C .......................................................Nov.2011
C
C   Call submapdy to produce daily maps of foF2, hmF2, TEC, and W-index
C........................................................Aug.2011
C For 1h_input IONEX-based TECmap files: d:\web\dtc\YY\MM\tcMMDDUT.fYY
C LON1/LON2/DLON.........-180/180/15			geographic longitudes  (25 cols) deg.
C LAT1/LAT2/DLAT..........-85/ 85/ 5			geographic latitudes  (35 lines) deg.
C Input: prec_mn (all days) into lines 1:7(last day of prec_mn) and current_mn (till given day=>8 line) for fixed UT
C
C Change+++ Produce median for 7 preceding days (instead of 27 prec days)
C
C OUTPUT : W index global map : d:\web\dtw\YY\MM\tcMMDDUT.wYR		!W(TEC)
C		 W index global map : d:\web\dfw\YY\MM\fcMMDDUT.wYR		!W(foF2)
C LON1/LON2/DLON.........-180/180/15			geographic longitudes  (25 cols) deg.
C LAT1/LAT2/DLAT..........-85/ 85/ 5			geographic latitudes  (35 lines) deg.
C
C
C T.L.Gulyaeva .................................................July 2007
C
C FORMAT from 27 prec. days
C Include logarithmic scale indices -4,  -3,    -2,    -1,0, 1,    2,    3,   4
C Equivalent to log10(TEC/TECmed)= <-.301, -.155, -.045   0,  0.45, .155, .301 >
C                              
C Ref. Gulyaeva T.L. Logarithmic scale of ionospheric disturbances,
C      Geomagn.and Aeronomy, 1996, 36, 1, 160-163, 1996.
C
      DIMENSION IM(12),X1(31),X2(31),iwc(9),coef(9)		  ! AUG 2022
     +,XMED(0:72,71),DEV(0:72,71) ! Median for all UT=0,...,23 (00.15,30,45 min)
     +,DA(0:28,0:72,71) ! TEC 7prec_days+curr_day=8,longs=0:72,lats=71
	dimension rx(0:72)
	DIMENSION GLATS(71),GLONS(0:72)
	integer*4 IRES(0:72,71),imed(0:72,71),itecx(0:72,71)  ! AUG 2022
	+,IDY1,IDY2,nndy !Maps available for idy1 to idy2
     +,imni
	CHARACTER*48 INFILE1,INFILE2,OUTFILE
	+,OUTFILET !   in case of absent UQRG		! AUG 2022
	CHARACTER*4 AYEAR,AYEAR_pre
      CHARACTER*2 AYR,AUT,AMN,ADY,AMM,PYR,PMN,PDY
	+,AMNI,AMN_pre,ADY_pre,AYR_pre,DD2
	 CHARACTER*1 YN,qs		 !
       CHARACTER*16 indate
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
	DATA iwc/-4,-3,-2,-1,0,1,2,3,4/							  ! AUG 2022
	DATA coef/0.50,0.59,0.79,0.95,1.00,1.05,1.26,1.69,2.00/	  ! AUG 2022
C	external subjpltec
CC      cc='c'     
CC	gh='t'
ctemp	gh='w'
C
  799	format(A4,2(1X,A2),1X,A4,2(1X,A2),2(1X,I3))				 !FEB2015 NEW COMMAND NUMBER = 799
  798	format(' YEAR, AMN, DD2 = ',A4,2(1X,A2),1X,A4,2(1X,A2),2(1X,I3))
	indate='d:/web/graf/date'    !!! Tamara !!!!!!!	 !FEB2015
C#	indate='/var/www/izmiran/ionosphere/weather/graf/date' !!! LIUBA !!FEB2015
	open(10,file=indate)							   !FEB2015			
	read(10,799) AYEAR,AMN,DD2,AYEAR_pre,AMN_pre,ADY_pre
	+,lda_cur,lda_pre  ! FORMAT NUMBER = 799
	WRITE(*,798) AYEAR,AMN,DD2,AYEAR_pre,AMN_pre,ADY_pre
	+,lda_cur,lda_pre ! FORMAT NUMBER = 798
	close(unit=10)
C++
C++
	glat=-90.
	DO i=1,71
	glat=glat+2.5
	glats(i)=glat
	ENDDO
C        
	glon=-185.
	do i=0,72
	glon=glon+5.0
	glons(i)=glon
	enddo
C ++++++++++++++++++Cor
C Start from uqrg (-2d)
	qs='q'
    1	CONTINUE		 ! cont for usrg (-1d)
	read(ayear,*) xyear
	IYEAR=int(xyear)
		ayr=ayear(3:4)
	ayr_pre=AYEAR_pre(3:4)
	read(AYR,*) ryr
	     pyr=AYR ! prec_year
	IYR=int(ryr)   ! current yr
C
	read(AMN,*) rmn
	imn=int(rmn)
C
C?	read(DD2,*) rdy
C?	idy=int(rdy)

C++
       if (qs.eq.'q') then
        lda=lda_cur-2                    ! Cor
	else
	lda=lda_pre
	endif
	call submmdd(lda,iyr,imn,idy)
	call blet2(idy,ADY)
	
C
	if (lda.le.14) THEN
C-	 AYR_pre=AYEAR_pre(3:4)
C-	pyr=AYR_pre
C-	read(AYR_pre,*) ryr_pre
C-	iyr=int(ryr_pre)
C?	IYEAR=IYEAR-1				   ! Cor
C?	IYR=IYR-1					   ! Cor
      IYRp=IYR-1					   ! Cor
	call blet2(iyrp,PYR)		   ! Cor
C?		AYR=AYEAR(3:4)				   ! Cor
	PMN='12'					   ! Cor
C?	imn=12
       PDY='31'
	imn_pre=12
	lda=365
C?	AYEAR_pre=AYEAR
	endif
C++
C
	write(*,*) ' Year=',AYEAR      ! Cor
C
	z1=iyr/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyr) THEN
               IM(2)=29
	dnr=366.
      ndnr=366
C?	if (lda.eq.365) lda=366
		  ELSE
                IM(2)=28
	  	dnr=365.
	ndnr=365
		       ENDIF
C     pyr=AYR ! prec_year
	write(*,*) AYR
   17 format (A2)
C?        call submmdd(lda,iyr,imn,idy)
  987	format(I2)
   13 FORMAT(I2)
200   continue	  
C
C monthly cycle
C
  177	call blet2(imn,amn)  ! current month
C		write(*,*) AMN
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

C
	IRUN=0 ! NORMAL COMMAND
C
  118	format(A4)
cc	pause  ' '
C
C =========================================
c
       ndmn=im(imn)
C++	write(*,*) ' Extract 15-min TEC maps from uqrg? Y/N:'
C++	 read(*,*) YN
       YN='y'
C--	if ((YN.eq.'N').or.(YN.eq.'n')) goto 660  ! Avoid extracting TEC maps
c produce TEC maps for the month =================================
C--      DO idy=idy1,idy2
      idy1=idy
	idy2=idy
  80	call blet2(idy,ADY)
C	write(*,199) ady
C

   89 format(2X,I4,4(4X,I2))

C   85	continue
C?       if (ayear_pre.eq.AYEAR) then
      write(*,*) ayear,amn,ady
C
       if (qs.eq.'q') then
C 
Cnorm      call subtecutmm(qs,AYR,AMN_pre,ADY_pre,iflag)   ! read TEC data for full day qs= 'q' or 's'
      call subtecutmm(qs,AYR,AMN,ADY,iflag)   ! read TEC data for full day qs= 'q' or 's'
C?	                          else
      write(*,*) ayear,amn,ady
	                      else
C
C 
Cnorm      call subtecutmm(qs,AYR,AMN,ADY,iflag)   ! read TEC data for full day qs= 'q' or 's'
      call subtecutmm(qs,AYR,AMN,ADY,iflag)   ! read TEC data for full day qs= 'q' or 's'
	                       endif

C--      ENDDO
CC
c ***************************************************************
  199	format(' day=',A2)
  660	AMNI=AMN
	imni=imn
		jmn_pre=imn
C
C preceding month:
       IF (AYEAR.eq.AYEAR_pre) THEN
	if (imn.gt.1) then
	jmn_pre=imn-1			 ! prec_mn
	else
	jmn_pre=12				 ! prec_mn
	jyr_pre=iyr-1			 ! prec_yr
	jdy_pre=31
	if (jyr_pre.lt.0) jyr_pre=100+jyr_pre ! 1998 or 1999
	call blet2(jyr_pre,PYR)  ! prec_yr
	endif
	                 ENDIF
	call blet2(jmn_pre,PMN)   ! prec_mn
	call blet2(jyr_pre,PYR)   ! prec_yr
      call blet2(jdy_pre,PDY)   ! prec_dy
C
C
 255	 CONTINUE
C
	lda1=ndoy(jyr_pre,jmn_pre,jdy_pre)
C
C     	 infile1='d:\web\dts\YY\MM\toMMDDUT.jYY'   ! preceding mn
     	 infile1='d:\web\graf\dtu\YY\MM\ut\tcMMDDUTMM.uYY'   ! preceding mn     ! TAMARA
C+++
      if (qs.eq.'q') then
	infile1(15:15)='u'
	else
	infile1(15:15)='a'
	endif
C+++
	 infile2='d:\web\graf\dtu\YY\MM\ut\tcMMDDUTMM.uYY' ! current mn
	
 	infile1(17:18)=pyr					! TAMARA
	infile1(20:21)=pmn					! TAMARA
 	infile1(38:39)=pyr					! TAMARA
	infile1(28:29)=pmn					! TAMARA
C
	outfile='d:\web\graf\dwu\YY\MM\ut\wcMMDDUTMM.uYY'   ! current mn
C+++
C+++
C>	outfile(17:18)=ayr					! TAMARA
C>	outfile(20:21)=amn					! TAMARA
C>	outfile(38:39)=ayr					! TAMARA
C>	outfile(28:29)=amn					! TAMARA
C	infile2(17:)=infile1(17:)
C	if (AYEAR.eq.AYEAR_pre) THEN
 	infile2(17:18)=ayr					! TAMARA
	infile2(20:21)=amn					! TAMARA
 	infile2(38:39)=ayr					! TAMARA
	infile2(28:29)=amn					! TAMARA
C	ENDIF
C
	outfile(17:)=infile2(17:)
C
      if (qs.eq.'q') then
	outfile(15:15)='u'
	else
	outfile(15:15)='a'
	endif
C
C  Start cycle on UT		=======================================================================
C     	 infile1='d:\web\graf\dtu\YY\MM\ut\tcMMDDUTMM.uYY'
C
	DO 300 iut=0,23
	call blet2(iut,AUT)
	infile1(32:33)=aut					 ! TAMARA
	infile2(32:33)=aut					 ! TAMARA
	outfile(32:33)=aut					 ! TAMARA
C add 
		ut=float(iut)
C
C    Start cycle on 15min:
C
      DO 301 imm=0,45,15
	call blet2(imm,AMM)
	infile1(34:35)=amm					 ! TAMARA
	infile2(34:35)=amm					 ! TAMARA
	outfile(34:35)=amm					 ! TAMARA


C  Avoid input of prec. month:
      ncnt=0        ! count of days 1,2,...,7   
      if (idy1.ge.15) goto 230	  ! goto input of current month
C
C  1st input of preceding mon-data

C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	nndy=im(jmn_pre)	  ! prec. mn
	nndy_end=nndy+idy1
	nnd1=nndy_end-13		  ! -15d
C
C  day-to-day input for prec mon
C
 	DO 400 jdy_pre=nnd1,nndy  ! for fixed UT,MM
crem	lday_pre=ndoy(jyr_pre,jmn_pre,jdy_pre) ! function to define day-of-year
	call blet2(jdy_pre,PDY)
	infile1(30:31)=pdy			                  ! TAMARA

		OPEN(109,FILE=INFILE1,action='READ')
C	     DA(0:15,0:72,71) ! 15prec_days+curr_day=15,longs=0:72,lats=71
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
cr	glat=-90.
 	DO ilat=1,71	  ! < LAT-BY-LAT
cr	glat=glat+2.5
	READ (109,107,END=106,ERR=2) (rx(k),k=0,72)
C
C
c.		! TEC at glon=-180,-175,...,180
	   do k=0,72		 !<<<<<<<<<<<<<<<<<<
	da(28,k,ilat)=rx(k) ! TEC 
	enddo
C
	ENDDO				  !< LAT-BY-LAT
  107	FORMAT(73(1X,F4.1))		   
  106	close(unit=109)					!     end of prec_mn input
C Move data day-by-day up so that last day of month nndy=>day_27:
C
c--	do ish=1,nndy-27      ! shift cycles
 	do ilat=1,71		  ! < LAT-BY-LAT
	do j=1,28			  ! <day-by-day
	do k=0,72			  ! all longi
	da(j-1,k,ilat)=da(j,k,ilat) ! move data one day up  
	enddo				  ! all longi
	enddo				  ! all days
	enddo				   ! all lati
	ncnt=ncnt+1
c--	enddo                 ! end shift cycle
  400	CONTINUE		  !<day-by-day
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
  230	continue
	nndy=im(imn)	 ! end of current month
C
	idy=0
  499	idy=idy+1	 ! day-by-day input for idy=nndy,...,idy3, current month
      lday=ndoy(iyr,imn,idy) ! function to define day-of-year
C_7d		if (lday.ge.lda1-6) ncnt=ncnt+1
      if (idy.gt.idy1) then
	goto 500 ! end of day-to-day processing 
	endif
C-		if (lday.ge.lda1-14) ncnt=ncnt+1 ! -15d
C-		if (ncnt.eq.0) goto 499
      if (idy.gt.nndy) then
	idy=1
	imn=imn+1
	endif
	call blet2(iyr,AYR)		
	call blet2(imn,AMN)		
	call blet2(idy,ADY)	
	 	infile2(17:18)=ayr			  ! TAMARA
  	infile2(38:39)=ayr				  ! TAMARA
		infile2(20:21)=amn			  ! TAMARA
 	infile2(28:29)=amn				  ! TAMARA
	infile2(30:31)=ady			   		! TAMARA
	outfile(30:31)=ady					! TAMARA
	OUTFILET=infile2                     !AUG 2022
C++
C++  Rename file extension .re1 or ta* / tb* for prediction files
  700 format(A128)
C
		OPEN(10,FILE=INFILE2,action='READ')
C
 704 	 continue

       do 600 ilat=1,71		  ! < LAT-BY-LAT	LATTTTTTTTTTTTTTTTT
cr	glat=glat+2.5
	READ (10,107,END=108,ERR=2) (rx(k),k=0,72)
C
cr	glon=-185.		! TEC at glon=-180,-185,...,180
	   do k=0,72		 !<<<<<<<<<<<<<<<<<< LONNNNNNNNNNNNNN
	ddd=rx(k)
	da(28,k,ilat)=ddd  ! TEC 
	   enddo			  !<<<<<<<<<<<<<<<<<<<<<<<<<
  600	CONTINUE			  !< LAT-BY-LAT
  108	close(UNIT=10)
C Move data one day up: (1)	if(idy.lt.idy1)  (2) a
C
 	do ilat=1,71		  ! < LAT-BY-LAT
 	do j=1,28			  ! <day-by-day
	do k=0,72			  ! all longi
	da(j-1,k,ilat)=da(j,k,ilat) ! move data one day up 
	enddo				  ! all longi
	enddo				  !<day-by-day
      enddo                 ! all lati 
C++	if (lday.ge.lday-8) ncnt=ncnt+1
	if (lday.ge.lday-16) ncnt=ncnt+1     !++++++++++++++++++++++++++
		if (ncnt.lt.15) goto 499          ! -15d
	lda=ndoy(iyr,imn,idy) ! function to define day-of-year+++++++++++++++++++
C Calculation of W index for idy 
        	IF (idy.eq.idy2) THEN
	outfile(26:26)='w'
1234		OPEN(12,FILE=OUTFILE)
                ENDIF
C
  115  LDNR=27
C-       LDY1=21  ! for 27 prec days median
       LDY1=13  ! for -15d prec days median
cc---       LDY1=21  ! for 7 prec days median
c
      DO 150 ilat=1,71			  ! Cycle on lati
        DO 144 M=0,72				  ! cycle on longi
        MM=0
crem          DO 124 N=1,LDNR			  ! collect data for prec days 1,...,27
        DO 124 N=LDY1,LDNR			  ! collect data for prec days LDY1...,27
       X1(N-12)=da(n,m,ilat)       ! -15d
 124   CONTINUE

C  prepare array x2:
c// 	do nn=1,ldnr
 	do nn=1,15
	x2(nn)=0.
	enddo

 127  XX=0.
C  : MAX X1(N)
 128  DO 130 N=1,15		  ! -15d
      IF (XX.LT.X1(N)) XX=X1(N)
 130  CONTINUE

      IF (XX.EQ.0.) GOTO 137
c//      DO 135 N=LDY1,LDNR
      DO 135 N=1,15	   !-15d
      IF (X1(N).LT.XX) GOTO 135
      MM=MM+1
	X2(MM)=XX 
	X1(N)=0.
 135  CONTINUE
c//      IF (MM.LT.LDNR) GOTO 127
      IF (MM.LT.15) GOTO 127  !-15d
 137  XMM=float(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=float(ND1)  
      ND2=ND1+1 
c//	IF ((XD1-CD1).LT.0.0001) THEN 
	IF (CD1.LT.XD1) THEN 
 	XMD=X2(ND2)
	else
	XMD=(X2(ND1)+X2(ND2))/2.
	endif
      XMED(M,ilat)=XMD
C Calculation of W index for idy (28 line of days)
      xpar=da(28,m,ilat)
	devlog=0.
	call windex(xpar,xmd,devlog,iwind)
	DEV(m,ilat)=devlog
	IRES(m,ilat)=iwind
	amed=xmd
C	if (ft.eq.'f') amed=sqrt(xmd)
	imed(m,ilat)=nint(amed*10.)
C++
 144  CONTINUE        ! cycle M ~ glong
C
	IF (idy.eq.idy2) THEN
crem 	WRITE(*,498) (IRES(K,ilat),K=0,72)
 	WRITE(12,498) (IRES(K,ilat),K=0,72)
crem 	WRITE(*,498) (IMED(K,ilat),K=0,72)
C?? 	WRITE(13,498) (IMED(K,ilat),K=0,72)
	ENDIF
C		 
 150	continue         ! cycle ilat
	IF (idy.eq.idy2) THEN
	CLOSE(unit=12)
	ENDIF
C
        IF ((iflag.eq.0).and.(qs.eq.'q').and.(idy.eq.idy2)) THEN				   !AUG 2022 +++++++++++
C
	OPEN(13,file=outfilet)				   !AUG 2022 
          do ilat=1,71					   !AUG 2022 
C?       IF (idy.eq.idy2) THEN				  !AUG 2022
        do ilon=0,72						  !AUG 2022	  lon
	iwind=ires(ilon,ilat)				  !AUG 2022
	   do k=1,9							  !AUG 2022
	 if (iwind.eq.iwc(k)) then			  !AUG 2022
       tecx=imed(ilon,ilat)*coef(k)		  !AUG 2022
	 itecx(ilon,ilat)=nint(tecx)		  !AUG 2022
	 exit								  !AUG 2022
	 endif								  !AUG 2022
	   enddo							  !AUG 2022
	  enddo								  !AUG 2022	   lon
C	ENDIF                                 !AUG 2022 
C 	WRITE(*,498) (ITECX(K,ilat),K=0,72)	   !AUG 2022 
 	WRITE(13,498) (ITECX(K,ilat),K=0,72)   !AUG 2022 
	   enddo							   !AUG 2022 
	close(13)							   !AUG 2022 
	ENDIF                                  !AUG 2022   ++++++++++++++++
	iflag=0
C
C END OF MEDIAN_TECxhi_MAP FOR DAY idy(28)
 498  FORMAT(73(1X,I4))
 202  CONTINUE
C
C Move data one day up: 
C
    	do ilat=1,71		  ! < LAT-BY-LAT
 	do j=1,28			  ! <day-by-day
	do k=0,72			  ! all longi
	da(j-1,k,ilat)=da(j,k,ilat) ! move data one day up 
	enddo				  ! all longi
	enddo				  !<day-by-day
      enddo                 ! all lati 
	 ncnt=14      !-15d
C =========================================
      goto 499		  ! to the next day processing
C ------------------------------------------------------
C =========================================
  500 continue   ! end day-by-day cycle     !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	imn=imni
  301	 CONTINUE		! end MIN cycle
  300 CONTINUE		! end UT cycle
C
C+++++++++ Include JPL 1h GIM-TEC correction using UPC GIM-Wmaps
C
C-       call subjpltec(ayear,amn,ady)
C-	 call submapdy(3,iyr,imn,idy) 
C+++++++++
C Combine UT maps into daily IONEX file including .txt, .txa, .txb files:
C
      
      DO 701 idy=idy1,idy2
	call blet2(idy,ADY)
	if (AYEAR.eq.AYEAR_pre) then
      call mapionexmm1('w',qs,ayear,amn,ady)
	else
      call mapionexmm1('w',qs,ayear_pre,amn,ady)
	endif
C==	call submapd2u(3,iyr,imn,idy)		  ! GIM-TEC 1h
      if (qs.eq.'q') then
	if (AYEAR.eq.AYEAR_pre) then
      call mapionexmm1('w',qs,ayear,amn,ady)
	call subpianiaWmm1(qs,AYEAR,AMN,ADY)
	            else
      call mapionexmm1('w',qs,ayear_pre,amn,ady)
	call subpianiaWmm1(qs,AYEAR_pre,AMN,ADY)
	endif
C
	else
	if (AYEAR.eq.AYEAR_pre) then
      call mapionexmm1('w',qs,ayear,amn,ady)
	call subpianiaWmm1(qs,AYEAR,AMN,ADY)
	                    else
      call mapionexmm1('w',qs,ayear_pre,amn,ady)
	call subpianiaWmm1(qs,AYEAR_pre,AMN,ADY)
	endif
      endif
  701	CONTINUE
      if (qs.eq.'q') then
	qs='s'					 !TEMPPPPPPPPPPPPPPPP
	GOTO 1
	endif
C
      GOTO 102
C
C
    2 CONTINUE
	       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
	   	pause ' '
    5	iend=1
  102	continue
            write(*,*) ' yr=',AYR,'  mn=',AMN,' dy1=',idy1,' dy2=',idy2 
C
CREM	call subwu3g(AYRI,AMNI,IDY2,IDY2)
	pause ' ' 

      STOP
	END
