      program devmag15ro
C.............................................................May. 2016
C Magn. coord IONEX maps for TEC        
C output:
C
C........................................................Feb 2015
C Output (TECobs-TECmed)/STD*100 => d:\web\del\YR\MN\rommddut.jyr !+-deltaTEC relative STD, *100% 
C
C
C Enter dy1,dy2
C .......................................................
C Geographic grids maps for glats=-87.5,-85,...,85, 87.5 (1 to 71 lines)
C                         glongs=-180, -1`75,..., 0,5,...,180 (0 to 72 cols.)
C
C........................................................
C Only S-index maps from JPL hourly maps (no foF2, no hmF2, no IONEX outfiles)
C
C JPL
C
C
C For 1h_input IONEX-based TECmap files: d:\web\dts\YY\MM\tcMMDDUT.jYY
C Input: prec_mn (all days) into lines 1:7(last day of prec_mn) and current_mn (till given day=>8 line) for fixed UT
C
C Change+++ Produce median for 7 preceding days (instead of 27 prec days)
C
C OUTPUT : S index global map : d:\web\dsi\YY\MM\tsMMDDUT.jYR		!S(TEC)
C
C
C T.L.Gulyaeva .................................................July 2007
C
C FORMAT from 15 prec. days
C Include logarithmic scale indices -4,  -3,    -2,    -1,0, 1,    2,    3,   4
C NO!!!  Equivalent to log10(TEC/TECmed)= <-.301, -.155, -.045   0,  0.45, .155, .301 >
C MEW: Dynamic S-class storm thresholds according to -STD1, +STD2
C                              
C Ref. Gulyaeva T.L. Logarithmic scale of ionospheric disturbances,
C      Geomagn.and Aeronomy, 1996, 36, 1, 160-163, 1996.
C
      DIMENSION IM(12)
     +,DA(0:28,0:72,71) ! TEC 7prec_days+curr_day=8,longs=0:72,lats=71
     +,XMED(0:72,71),DEV(0:72,71)
	dimension rx(0:72)
	+,CC(15,0:72),SMED(0:72),STD(0:72),STD1(0:72),STD2(0:72)
	integer*4 IRES(0:72,71)
C	+,imed(0:72,71)
	integer*2 IYR,IMN,IDY,IUT,jyr_pre,jmn_pre,jdy_pre
	+,IDY1,IDY2,nndy !Maps available for idy1 to idy2; extrap. to IDY2+1,idy2+2
     +,imni,iyri
	CHARACTER*48 INFILE1,INFILE2,OUTFILE
C-	+,OUTFILED
	CHARACTER*2 AYR
	+,AUT,AMN,ADY,PYR,PMN,PDY
	+,AYRI,AMNI
	CHARACTER*1 ft,fht
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
C
      ft='t'  ! TEC-map   in magn. coord.
c      ft='f'  ! fof2-map in magn. coord.
C

C=    WRITE(*,*)' CHECK AVAILABILITY of tc files '
C=	pause  ' '
	WRITE(*,*)' ENTER YR OF INPUT FILE=	'
	read(*,17) AYR
ctemp	AYR='09'
cc	write(*,17) ' YR=',ayr
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	if (iyr.lt.90) then
	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF

C++	imn=1  ! Start mn-to-mn

1333	 CONTINUE
      WRITE(*,*)' ENTER MN '
	READ(*,13) IMN
	if(imn.eq.0) STOP
ctemp	imn=07
C

   13 FORMAT(I2)
ctemp	idys=1           ! Cycle on day-to-day
	WRITE(*,*)' ENTER IDY1,IDY2'
	READ(*,13) IDYS,IDYS2
C++	idys=1
C++	IDYS2=im(imn)  !
 201	CONTINUE		 ! cycle on days
	AYRI=AYR
   17 format (A2)
	iyri=iyr
	pyr=AYR ! prec_year
	jyr_pre=iyr
C

	call blet2(imn,amn)  ! current month
	AMNI=AMN
	imni=imn
	jmn_pre=imn
C

200   continue	  
	idy1=idys
C
C preceding month:
	if (imn.gt.1) then
	jmn_pre=imn-1			 ! prec_mn
	else
	jmn_pre=12				 ! prec_mn
	jyr_pre=iyr-1			 ! prec_yr
	if (jyr_pre.lt.0) jyr_pre=100+jyr_pre ! 1998 or 1999
	call blet2(jyr_pre,PYR)  ! prec_yr
	endif
	call blet2(jmn_pre,PMN)   ! prec_mn
C
CNO!!	IDY2=IDY1  !?????????????????????????????????????
	IDY2=idys2
C
	fht='t'				! only TEC source map
	lda1=ndoy(iyr,imn,idy1)
C
     	 infile1='d:\web\dts\YY\MM\toMMDDUT.jYY'   ! preceding mn
C     	 infile1='d:\web\dfs\YY\MM\foMMDDUT.jYY'   ! preceding mn
	infile1(9:9)=ft
	infile1(18:18)=ft
	 infile2=infile1  ! current mn
	
 	infile1(12:13)=pyr
	infile1(15:16)=pmn
 	infile1(28:29)=pyr
	infile1(20:21)=pmn
 	infile2(12:13)=ayr
 	infile2(28:29)=ayr
	infile2(15:16)=amn
	infile2(20:21)=amn
C
	outfile='d:\web\del\YY\MM\roMMDDUT.jYY'   ! current mn
	outfile(12:13)=ayr
	outfile(15:16)=amn
	outfile(28:29)=ayr
	outfile(20:21)=amn
C
C
C  Start cycle on UT		=======================================================================
C
C     	 infile1='d:\web\dts\YY\MM\tcMMDDUT.jYY'   ! preceding mn
C
	DO 300 iut=0,23
	call blet2(iut,AUT)
	infile1(24:25)=aut
	infile2(24:25)=aut
	outfile(24:25)=aut
C add 
		ut=float(iut)
 

C	 DA(0:28,0:24,35)
	 DO n=1,71				! lats
	      DO I=0,28			! 27 prec days
       DO K=0,72				! lons
	      DA(I,K,n)=0.
	 enddo
	      ENDDO
	ENDDO

c	 ,XMED(0:24,71)
 	do k=0,72
	do i=1,71
	ires(k,i)=0
	xmed(k,i)=0.
       DEV(k,i)=0.
	enddo
	enddo
C  Avoid input of prec. month:
crem	nnd1=idy1-6
      ncnt=0        ! count of days 1,2,...,15   
      if (idy1.gt.14) goto 230	  ! goto input of current month
C  1st input of preceding mon-data

C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	nndy=im(jmn_pre)	  ! prec. mn
C???	nnd1=nndy-6
	nnd1=nndy-13
	if (idy1.gt.1) nnd1=nnd1+idy1-1
C
C  day-to-day input for prec mon
C
	DO 400 jdy_pre=nnd1,nndy  ! for fixed UT
	call blet2(jdy_pre,PDY)
	infile1(22:23)=pdy

		OPEN(109,FILE=INFILE1)
C	     DA(0:8,0:72,71) ! 7prec_days+curr_day=8,longs=0:72,lats=71
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
cr	glat=-90.
 	DO ilat=1,71	  ! < LAT-BY-LAT
cr	glat=glat+5.0
	READ (109,107,END=106,ERR=2) (rx(k),k=0,72)
C
C
c.		! TEC at glon=-180,-175,...,180
	   do k=0,72		 !<<<<<<<<<<<<<<<<<<
	da(28,k,ilat)=rx(k) ! TEC 
	enddo
C
	ENDDO				  !< LAT-BY-LAT
  107	FORMAT(73(1X,F4.1))		   
  106	close(unit=109)					!     end of prec_mn input
C Move data day-by-day up so that last day of month nndy=>day_27:
C
c--	do ish=1,nndy-27      ! shift cycles
 	do ilat=1,71		  ! < LAT-BY-LAT
	do j=1,28			  ! <day-by-day
	do k=0,72			  ! all longi
	da(j-1,k,ilat)=da(j,k,ilat) ! move data one day up  
	enddo				  ! all longi
	enddo				  ! all days
	enddo				   ! all lati
	ncnt=ncnt+1
c--	enddo                 ! end shift cycle
  400	CONTINUE		  !<day-by-day
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C start cycle on day-to-day for current mon  ======================================
C
  230	continue
	nndy=im(imn)	 ! end of current month

  490 format(1X,' year=',I2,' month=',I2,' day=',I2,' ut=',I2)
	idy=0
CREM	idy=idy1-1
C
C Current month
C
  499	idy=idy+1	 ! day-by-day input for idy=nndy,...,idy3, current month
      lday=ndoy(iyr,imn,idy) ! function to define day-of-year
	lday2=ndoy(iyr,imn,idy2) ! function to define day-of-year
      if (lday.gt.lday2) then
	goto 500 ! end of day-to-day processing 
	endif
      if (idy.gt.nndy) then
	idy=1
	imn=imn+1
	endif
ctemp		WRITE(*,490) iyr,imn,idy,iut
	call blet2(iyr,AYR)
	call blet2(imn,AMN)
	call blet2(idy,ADY)
	 	infile2(12:13)=ayr
  	infile2(28:29)=ayr

		infile2(15:16)=amn
 	infile2(20:21)=amn

	infile2(22:23)=ady
C++
C++
  700 format(A128)
C++
C
C   reading map for current month
C
cr	glat=-90.
 704 	 continue
      outfile=infile2
c++	 outfile='d:\web\del\YY\MM\trMMDDUT.jYY'   ! current mn
	outfile(8:10)='del'
	outfile(18:19)='ro'		 ! (TECobs-TECmed)/STD*100 in magn. coord
C	outfile(18:19)='fr'		 ! (foF2obs-foF2med)/STD*100
C	outfiled=outfile
C	outfiled(8:10)='dlg'
C	outfiled(18:19)='td'		 ! DLOG*1000
		OPEN(110,FILE=INFILE2)
       do 600 ilat=1,71,1		  ! < LAT-BY-LAT
cr	glat=glat+5.0
	READ (110,107,END=108,ERR=2) (rx(k),k=0,72)
C
C
C
cr	glon=-185.		! TEC at glon=-180,-175,...,180
	   do k=0,72		 !<<<<<<<<<<<<<<<<<<
cr	glon=glon+5.
cr	if (glon.lt.0.) glon=glon+360.
	ddd=rx(k)
	da(28,k,ilat)=ddd  ! TEC 
	   enddo			  !<<<<<<<<<<<<<<<<<<<<<<<<<
  600	CONTINUE			  !< LAT-BY-LAT
  108	close(UNIT=110)
C
C
C Move data one day up: (1)	if(idy.lt.idy1)  (2) a
C
 	do ilat=1,71		  ! < LAT-BY-LAT
 	do j=1,28			  ! <day-by-day
	do k=0,72			  ! all longi
	da(j-1,k,ilat)=da(j,k,ilat) ! move data one day up 
	enddo				  ! all longi
	enddo				  !<day-by-day
      enddo                 ! all lati 
c//	if (idy.ge.idy1-6) ncnt=ncnt+1
	if ((jmn_pre.lt.12).and.(lday.ge.lda1-14)) ncnt=ncnt+1  ! during current year
	if ((jmn_pre.eq.12).and.(idy.ge.idy1-14)) ncnt=ncnt+1 ! transition from year-to-year
		if (ncnt.lt.15) goto 499
C
C
C Calculations for  day=idy: da(28,long,lat)
C	
  240	outfile(22:23)=ady	  !*************************************************
C++
      lda=ndoy(iyr,imn,idy) ! function to define day-of-year
	 	lda2=ndoy(iyr,imn,idy2) ! function to define day-of-year
C
		OPEN(112,FILE=OUTFILE)
C	OPEN(113,FILE=OUTFILED)
C
C  VERIFICATION OF MEDIAN	FOR TEC_MAP(long,lat) for one day (28)
  115 CONTINUE
C     LDNR=27
C       LDY1=21  ! for 7 prec days median
cc---       LDY1=21  ! for 7 prec days median
c
      DO 150 ilat=1,71			  ! Cycle on lati
C
C Median ans STD calculation:
C
	DO MM=0,72	
C Prepare common array for -14 prec days, CC(15,0:72), for median and STD calculation:
C     DA(0:28,0:72,71) ! TEC -14 prec_days+curr_day=8,longs=0:72,lats=71

	DO kk=13,27
	kmed=kk-12
	CC(kmed,mm)=da(kk,mm,ilat)
	ENDDO	   ! cycle kk

	ENDDO      !cycle mm
	ndays=15
	nlons=72
c	call smedstd3(ndays,nlons) ! SMED(0:72),STD(0:72),STD1=neg(0:72),STD2=pos(0:72)
C	if ((iut.eq.17).and.(ilat.eq.15)) pause ' ' 
	CALL smedstd3(CC,SMED,STD,STD1,STD2)
        DO 144 M=0,72				  ! cycle on longi
CC      xpar=da(28,m,ilat) ??
	apar=da(27,m,ilat)
	amed=smed(m)
	astd=std(m)
	if (astd.eq.0.) then
C	pause ' ' 
	astd=amed/10.
	endif
	if (std1(m).eq.0.) then
C	pause ' ' 
	std1(m)=amed/10.
	endif
	if (std2(m).eq.0.) then
C	pause ' ' 
	std2(m)=amed/10.
	endif
C	astd1=std1(m)
C	astd2=std2(m)
C Calculation of S index for idy (27th line of days)
CREM	call sindex2b(apar,amed,astd1,astd2,tlow,tup,delog,iwind)
C
      XMED(M,ilat)=AMED
	x1=alog10(apar)
 	x2=alog10(amed)
	delog=x1-x2

	DEV(m,ilat)=delog
CREM	IRES(m,ilat)=iwind
CREM		IRES(m,ilat)=nint(delog*1000.)
C
C std1 = neg, std2 = pos
	deltec=apar-amed
	dmstd=deltec/astd
	if (deltec.gt.0.) then
	ires(m,ilat)=nint(deltec/std2(m)*100.) ! Dm+
	else
      ires(m,ilat)=nint(deltec/std1(m)*100.) ! Dm-
	endif
Crem	ires(m,ilat)=nint((apar-amed)/astd*100.)         
C	imed(m,ilat)=nint(amed*10.)  
C	imed(m,ilat)=nint(amed)			!?
C			IMED(m,ilat)=nint(delog*1000.)
 144  CONTINUE        ! cycle M ~ glong

C 	WRITE(*,498) (IRES(K,ilat),K=0,72)		!Temp
 	WRITE(112,498) (IRES(K,ilat),K=0,72)  !Tr*100
Crem 	WRITE(*,498) (IMED(K,ilat),K=0,72)
C 	WRITE(113,498) (IMED(K,ilat),K=0,72)  ! Dlog*1000

C		 
 150	continue         ! cycle ilat
C
C END OF MEDIAN_TECxhi_MAP FOR DAY idy(28)
C ------------------------------------------------------
C output w-index map	
C					  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
cr      DO ilat=1,71
cr	WRITE(*,498) (IRES(K,ilat),K=0,72)
cr	WRITE(112,498) (IRES(K,ilat),K=0,72)
cr	ENDDO
 498  FORMAT(73(1X,I4))
	CLOSE(unit=112)
C		CLOSE(unit=113)
C

 202  CONTINUE
C
	 ncnt=14
      goto 499		  ! to the next day processing
C	  						  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C =========================================
  500 continue   ! end day-by-day cycle     !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	imn=imni
	write(*,*) ' UT=',iut
  300 CONTINUE		! end UT cycle
      GOTO 102
    2 CONTINUE
	       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
	   	pause ' '
    5	iend=1
  102	continue
            write(*,*) ' yr=',AYR,'  mn=',AMN,' dy1=',idy1,' dy2=',idy2 
	imn=imn+1
	if (imn.lt.13) GOTO 1333
	pause ' ' 
      STOP
	END
