      program devmas15
C........................................................Feb. 2015
C Use median for -7 prec, days;
C Dynamic thresholds for storm at Dlog below or above log10((xmed+std)/xmed)  
C  STD = standard deviation from median for -7 prec days
C Include S index map calculation from TECeff, GIM-TEC, foF2-map, hmF2-map
C Produce Sx index derived from map: x=f (foF2), x=h (hmF2), x=t (TEC), x=e (TECeff)
C Exclude extrapolation for 2 days ahead
C outfiles => d:\web\dsi\YR\MN\sxMNDDUT.jYY
C
C........................................................June 2014
C Add extraction of TEC Map in magnetic coordinates
C........................................................Dec. 2013
C results => /grif/
C........................................................Nov.2012
C for JPL hourly data
C........................................................Oct. 2012
C Include subwp3 to update file of Wp index
C........................................................Apr. 2012
C Maps in IONEX format
C
C........................................................Jan. 2012
C Correct transition from month-to-month
C
C  ......................................................Dec.2011
C  Arrange subfur forecast of fcF2, hcF2, tec, Wp maps for two days ahead
C
C .......................................................Nov.2011
C
C   Call submapdy to produce daily maps of foF2, hmF2, TEC, and W-index
C........................................................Aug.2011
C For 1h_input IONEX-based TECmap files: d:\web\dtc\YY\MM\tcMMDDUT.fYY
C LON1/LON2/DLON.........-180/180/15			geographic longitudes  (25 cols) deg.
C LAT1/LAT2/DLAT..........-85/ 85/ 5			geographic latitudes  (35 lines) deg.
C Input: prec_mn (all days) into lines 1:7(last day of prec_mn) and current_mn (till given day=>8 line) for fixed UT
C
C Change+++ Produce median for 7 preceding days (instead of 27 prec days)
C
C OUTPUT : W index global map : d:\web\dtw\YY\MM\tcMMDDUT.wYR		!W(TEC)
C		 W index global map : d:\web\dfw\YY\MM\fcMMDDUT.wYR		!W(foF2)
C LON1/LON2/DLON.........-180/180/15			geographic longitudes  (25 cols) deg.
C LAT1/LAT2/DLAT..........-85/ 85/ 5			geographic latitudes  (35 lines) deg.
C
C
C T.L.Gulyaeva .................................................July 2007
C
C FORMAT from 27 prec. days
C Include logarithmic scale indices -4,  -3,    -2,    -1,0, 1,    2,    3,   4
C Equivalent to log10(TEC/TECmed)= <-.301, -.155, -.045   0,  0.45, .155, .301 >
C                              
C Ref. Gulyaeva T.L. Logarithmic scale of ionospheric disturbances,
C      Geomagn.and Aeronomy, 1996, 36, 1, 160-163, 1996.
C
      DIMENSION IM(12),X1(31),X2(31)
     +,DA(0:28,0:72,71) ! TEC 7prec_days+curr_day=8,longs=0:72,lats=71
     +,XMED(0:72,71),DEV(0:72,71)
	dimension rx(0:72)
	integer*4 IRES(0:72,71),imed(0:72,71)
	integer*2 IYR,IMN,IDY,IUT,jyr_pre,jmn_pre,jdy_pre
	+,IDY1,IDY2,nndy !Maps available for idy1 to idy2;
     +,imni,iyri
	CHARACTER*48 INFILE1,INFILE2,OUTFILE
	CHARACTER*128 TXT
c-	+,OUTFILEM
	CHARACTER*2 AYR
	+,AUT,AMN,ADY,PYR,PMN,PDY
	+,AYRI,AMNI
	CHARACTER*1 ft
      DATA IM/31,28,31,30,31,30,31,31,30,31,30,31/
C
      ft='t'  ! GIM-TEC ~ ft='t'
CREM	ft='e'  ! TECeff-map ~ ft='e' et-map
CREM	ft='f'  ! foF2-map ~ ft='f' 
CREM	ft='h'  ! hmF2-map ~ ft='h' 
C
C=    WRITE(*,*)' CHECK AVAILABILITY of tc. fc, hc, et files '
C=	pause  ' '
	WRITE(*,*)' ENTER YR OF INPUT FILE=	'
	read(*,17) AYR
ctemp	AYR='14'
	AYRI=AYR
	write(*,*) AYR
   17 format (A2)
cc	write(*,17) ' YR=',ayr
	read(AYR,*) ryr
	IYR=int(ryr)   ! current yr
	iyri=iyr
	pyr=AYR ! prec_year
	jyr_pre=iyr
C
	WRITE(*,*)' ENTER CURRENT MN'
	READ(*,13) IMN
crem	imn=02
   13 FORMAT(I2)
	call blet2(imn,amn)  ! current month
		write(*,*) AMN
	AMNI=AMN
	imni=imn
	jmn_pre=imn
C
200   continue	  

C
	if (iyr.lt.90) then
	iyyyy=2000+iyr
	              else
	iyyyy=1900+iyr
	endif
	z1=iyyyy/4.0
      jz=int(z1)*4

      IF(jz.EQ.iyyyy) THEN
               IM(2)=29
	dnr=366.
        ELSE
                IM(2)=28
	  	dnr=365.
	       ENDIF
C preceding month:
	if (imn.gt.1) then
	jmn_pre=imn-1			 ! prec_mn
	else
	jmn_pre=12				 ! prec_mn
	jyr_pre=iyr-1			 ! prec_yr
	if (jyr_pre.lt.0) jyr_pre=100+jyr_pre ! 1998 or 1999
	call blet2(jyr_pre,PYR)  ! prec_yr
	endif
	call blet2(jmn_pre,PMN)   ! prec_mn
C
	WRITE(*,*)' ENTER IDY1,IDY2'
	READ(*,13) IDY1,IDY2
 255	CONTINUE
c@      idy2=idy1
C
C
     	 infile1='d:\web\des\YY\MM\xxMMDDUT.jYY'   ! preceding mn "et" for TECeff
	if (ft.eq.'t') infile1(18:19)='tc'  ! TEC
	if (ft.eq.'f') infile1(18:19)='fc'  ! foF2
	if (ft.eq.'h') infile1(18:19)='hc'  ! hmF2
	if (ft.eq.'e') infile1(18:19)='et'  ! TECeff
	 infile2=infile1  ! current mn
 	infile1(12:13)=pyr
	infile1(15:16)=pmn
 	infile1(28:29)=pyr
	infile1(20:21)=pmn
 	infile2(12:13)=ayr
	infile2(15:16)=amn
 	infile2(28:29)=ayr
	infile2(20:21)=amn
C
	outfile='d:\web\dsi\YY\MM\siMMDDUT.jYY'   ! current mn

	outfile(18:18)=ft       ! s='t' for TEC
	outfile(12:13)=ayr
	outfile(15:16)=amn
	outfile(28:29)=ayr
	outfile(20:21)=amn
C
C
C  Start cycle on UT		=======================================================================
C
C     	 infile1='d:\web\dev\YY\MM\evMMDDUT.jYY'   ! preceding mn
C
	DO 300 iut=0,23
	call blet2(iut,AUT)
	infile1(24:25)=aut
	infile2(24:25)=aut
	outfile(24:25)=aut
C add 
		ut=float(iut)
 

C	 DA(0:28,0:24,35)
	 DO n=1,71				! lats
	      DO I=0,28			! 27 prec days
       DO K=0,72				! lons
	      DA(I,K,n)=0.
	 enddo
	      ENDDO
	ENDDO

c	 ,XMED(0:24,35)
 	do k=0,72
	do i=1,71
	ires(k,i)=0
	xmed(k,i)=0.
       DEV(k,i)=0.
	enddo
	enddo
C  Avoid input of prec. month:
crem	nnd1=idy1-6
      ncnt=0        ! count of days 1,2,...,7   

C>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

Crem      if (idy1.ge.7) goto 230	  ! go to input of current month
            if (idy1.ge.8) goto 230	  ! go to input of current month

C  1st input of preceding mon-data

C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

	nndy=im(jmn_pre)	  ! prec. mn
Crem	nnd1=nndy-5
      nnd1=nndy-6 
C
C  day-to-day input for prec mon
C
	DO 400 jdy_pre=nnd1,nndy  ! for fixed UT
crem	lday_pre=ndoy(jyr_pre,jmn_pre,jdy_pre) ! function to define day-of-year
	call blet2(jdy_pre,PDY)
	infile1(22:23)=pdy

		OPEN(109,FILE=INFILE1)
C	     DA(0:8,0:72,71) ! 7prec_days+curr_day=8,longs=0:72,lats=71
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
cr	glat=-90.
 	DO ilat=1,71	  ! < LAT-BY-LAT
cr	glat=glat+2.5
	READ (109,107,END=106,ERR=2) (rx(k),k=0,72)
C
C
c.		! TEC at glon=-180,-175,...,180
	   do k=0,72		 !<<<<<<<<<<<<<<<<<<
	da(28,k,ilat)=rx(k) ! TEC 
	enddo
C
	ENDDO				  !< LAT-BY-LAT
CREM  107	FORMAT(73(1X,F4.1))		   
  107	FORMAT(73(1X,F4.0))		   
  106	close(unit=109)					!     end of prec_mn input
C Move data day-by-day up so that last day of month nndy=>day_27:
C
 	do ilat=1,71		  ! < LAT-BY-LAT
	do j=1,28			  ! <day-by-day
	do k=0,72			  ! all longi
	da(j-1,k,ilat)=da(j,k,ilat) ! move data one day up  
	enddo				  ! all longi
	enddo				  ! all days
	enddo				   ! all lati
	ncnt=ncnt+1
  400	CONTINUE		  !<day-by-day
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C start cycle on day-to-day for current mon  ======================================
C
  230	continue
	nndy=im(imn)	 ! end of current month

  490 format(1X,' year=',I2,' month=',I2,' day=',I2,' ut=',I2)
	idy=0
	lday1=ndoy(iyr,imn,idy1) ! end day-of-year
	lday2=ndoy(iyr,imn,idy2) ! end day-of-year

C#	lday3=ndoy(iyr3,imn3,idy3) ! function to define day-of-year
c	DO 500 idy=nnd1,idy3	 ! current mn
  499	idy=idy+1	 ! day-by-day input for idy=nndy,...,idy2, current month
crem      if (nnday.eq.1).and.(idy.gt.nndy)) then
      lday=ndoy(iyr,imn,idy) ! function to define day-of-year
c?	lday3=ndoy(iyr3,imn3,idy3) ! function to define day-of-year
      if (lday.gt.lday2) then
	goto 500 ! end of day-to-day processing 
	endif
C?      if (idy.gt.nndy) then
C?	idy=1
C?	imn=imn+1
C?	endif
CTEMP		WRITE(*,490) iyr,imn,idy,iut
c#	call blet2(iyr,AYR)
c#	call blet2(imn,AMN)
	call blet2(idy,ADY)
C     	 infile2='d:\web\dev\YY\MM\evMMDDUT.jYY'   ! current mn
c#	 	infile2(12:13)=ayr
c#  	infile2(28:29)=ayr
c#		infile2(15:16)=amn
c# 	infile2(20:21)=amn

	infile2(22:23)=ady
C++
C Produce GEC for the current day:	 +++++++++++++++++++++++++++
C++
C?	if ((iyr.eq.14).and.(idy.eq.idy1).and.(idy.eq.idy2)) then
	if (ft.eq.'t') then
	call subgecs(AYR,AMN,ADY)
	endif
C++  Rename file extension .re1 or ta* / tb* for prediction files
  700 format(A128)
c#	INFILE2(27:27)='c'
		OPEN(112,FILE=INFILE2)
C++ Check availability of INFILE2
C
       read(112,700,END=703,ERR=703) txt
	backspace(112)
	goto 704
  703	close(unit=112)
	write(*,*) 'No file: ',infile 2
c	pause ' '
	stop
C
C   reading map for current month
C
cr	glat=-90.
 704 	 continue
C#      outfile=infile2
      outfile='d:\web\dsi\YY\MM\siMMDDUT.jYY' 
		outfile(18:18)=ft       ! s='t' for TEC
	outfile(12:13)=ayr
	outfile(15:16)=amn
	outfile(20:21)=amn
	outfile(28:29)=ayr
	outfile(22:23)=ady
	outfile(24:25)=aut
c#	outfile(27:27)='j'
       do 600 ilat=1,71,1		  ! < LAT-BY-LAT
cr	glat=glat+2.5
	READ (112,107,END=108,ERR=2) (rx(k),k=0,72)
C
C  VECn 
C
cr	glon=-185.		! VEC at glon=-180,-175,...,180
	   do k=0,72		 !<<<<<<<<<<<<<<<<<<
cr	glon=glon+5.
cr	if (glon.lt.0.) glon=glon+360.
	ddd=rx(k)
	da(28,k,ilat)=ddd  ! TEC 
	   enddo			  !<<<<<<<<<<<<<<<<<<<<<<<<<
  600	CONTINUE			  !< LAT-BY-LAT
  108	close(UNIT=112)
C
		ncnt=ncnt+1
Data for current day keep at row=28
C
	if (ncnt.lt.7) then
C Move data one day up: (1)	if(idy.lt.idy1)  (2) 
C
 	do ilat=1,71		  ! < LAT-BY-LAT
 	do j=1,28			  ! <day-by-day
	do k=0,72			  ! all longi
	da(j-1,k,ilat)=da(j,k,ilat) ! move data one day up 
	enddo				  ! all longi
	enddo				  !<day-by-day
      enddo                 ! all lati 

	goto 499
	endif 
Cren	ncnt=ncnt+1
c>	if (lday.ge.lday1-6) ncnt=ncnt+1
c?	if (lday.ge.lday2-8) ncnt=ncnt+1
C		if (ncnt.lt.7) goto 499
crem      if (idy.lt.nndy) goto 499
C

C
C Calculations for  day=idy: da(28,long,lat)

C	
c outfilem='d:\web\dtw\YY\MM\tcMMDDUT.MYY'   !7prec_days median for current mn
  240	outfile(22:23)=ady	  !*************************************************
C++
      lda=ndoy(iyr,imn,idy) ! function to define day-of-year
c# 	lda3=ndoy(iyr3,imn3,idy3) ! function to define day-of-year

c==	outfilem=outfile
c==		outfilem(27:27)='m'

C Produce VEC maps and GEC for the last day:
c^	if (idy1.eq.idy2) then
c^	call subvecj(AYR,AMN,ADY)
c^	endif
C
		OPEN(112,FILE=OUTFILE)
c==	OPEN(113,FILE=OUTFILEM)
C Calculation of median for 27 prec-days	  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C	     DA(0:28,0:24,35) ! 27prec_days+curr_day=28,longs=0:24,lats=35
C
C  VERIFICATION OF MEDIAN	FOR VEC_MAP(long,lat) for one day (28)


C 
  115  LDNR=27
       LDY1=21  ! for 7 prec days median
cc---       LDY1=21  ! for 7 prec days median
c
      DO 150 ilat=1,71			  ! Cycle on lati
C

C//        DO 144 M=0,72				  ! cycle on longi
C//        MM=0
crem          DO 124 N=1,LDNR			  ! collect data for prec days 1,...,27
C+++ prepare COMMON BLOCK array for calculating Median and STD with SUBMEDSTD

        DO 124 N=LDY1,LDNR			  ! collect data for prec days LDY1...,27
       X1(N-20)=da(n,m,ilat)
 124   CONTINUE

	CALL submedstd(7,72)
	                            GOTO 150  !???????????

C  prepare array x2:
c// 	do nn=1,ldnr
 	do nn=1,7
	x2(nn)=0.
	enddo

 127  XX=0.
C  : MAX X1(N)
c// 128  DO 130 N=LDY1,LDNR
 128  DO 130 N=1,7
      IF (XX.LT.X1(N)) XX=X1(N)
 130  CONTINUE

      IF (XX.EQ.0.) GOTO 137
c//      DO 135 N=LDY1,LDNR
      DO 135 N=1,7
      IF (X1(N).LT.XX) GOTO 135
      MM=MM+1
	X2(MM)=XX 
	X1(N)=0.
 135  CONTINUE
c//      IF (MM.LT.LDNR) GOTO 127
      IF (MM.LT.7) GOTO 127
 137  XMM=float(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=float(ND1)  
      ND2=ND1+1 
c//	IF ((XD1-CD1).LT.0.0001) THEN 
	IF (CD1.LT.XD1) THEN 
 	XMD=X2(ND2)
	else
	XMD=(X2(ND1)+X2(ND2))/2.
	endif
      XMED(M,ilat)=XMD
C Calculation of W index for idy (28 line of days)
      xpar=da(28,m,ilat)
	devlog=0.
CREM	call windex(xpar,xmd,devlog,iwind)
	call windexv(xpar,xmd,devlog,iwind)
	DEV(m,ilat)=devlog
	IRES(m,ilat)=iwind
	amed=xmd
	if (ft.eq.'f') amed=sqrt(xmd)
	imed(m,ilat)=nint(amed*10.)
 144  CONTINUE        ! cycle M ~ glong
crem 	WRITE(*,498) (IRES(K,ilat),K=0,72)
 	WRITE(112,498) (IRES(K,ilat),K=0,72)
crem 	WRITE(*,498) (IMED(K,ilat),K=0,72)
c== 	WRITE(113,498) (IMED(K,ilat),K=0,72)

C		 
 150	continue         ! cycle ilat
C
C END OF MEDIAN_VEC_MAP FOR DAY idy(28)
C ------------------------------------------------------
C output w-index map	
C					  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      DO ilat=1,71
	WRITE(*,498) (IRES(K,ilat),K=0,72)
	WRITE(112,498) (IRES(K,ilat),K=0,72)
	ENDDO
 498  FORMAT(73(1X,I4))
	CLOSE(unit=112)
c==		CLOSE(unit=113)
C

 202  CONTINUE
C
C Move data one day up: 
C
    	do ilat=1,71		  ! < LAT-BY-LAT
 	do j=1,28			  ! <day-by-day
	do k=0,72			  ! all longi
	da(j-1,k,ilat)=da(j,k,ilat) ! move data one day up 
	enddo				  ! all longi
	enddo				  !<day-by-day
      enddo                 ! all lati 
	 ncnt=6
      goto 499		  ! to the next day processing
C	  						  !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C
C =========================================
  500 continue   ! end day-by-day cycle     !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	imn=imni

  300 CONTINUE		! end UT cycle
      GOTO 102
    2 CONTINUE
	       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
	   	pause ' '
    5	iend=1
  102	continue
c#	call submapvj(1,iyr,imn,idy2,iyr3,imn3,idy3) ! foF2
c#	call submapvj(2,iyr,imn,idy2,iyr3,imn3,idy3) ! hmF2
c#	call submapvj(3,iyr,imn,idy2,iyr3,imn3,idy3) ! TEC
c#	call submapvj(4,iyr,imn,idy2,iyr3,imn3,idy3) ! W=index

            write(*,*) ' yr=',AYR,'  mn=',AMN,' dy1=',idy1,' dy2=',idy2 
C
	call subwp3v(AYRI,AMNI,IDY1,IDY2)
crem	if (idy2.lt.im(imn)) then
crem	idy1=idy1+1
crem	goto 255
crem	endif
c#	idy2=idy1+1
	call subprobv(AYRI,AMNI,IDY1,IDY2)
C Add: Produce VEC maps in magnetic coordinates separately +>>>>>>>>>>
CREM	do idy=idy1,idy2
CREM	call blet2(idy,ADY)
CREM	call subexmav(AYR,AMN,ADY)
CREM	enddo
	pause ' ' 

      STOP
	END
