C.........................................................Feb. 2015
C
c VERIFICATION OF MEDIAN ================
      subroutine smedstd2(ndnr,ncol)
C
C Median smed, and standard deviation std1(neg),std2(pos) for -14+1 days at specified hour
C
C Input file: CC(ndnr,0:72) for ndnr days, 
C ncol=72 for longitudes -180:5:180 or ncol=23 for hours UT=0,1,...,23
C Number days for median : ndnr=15	(14 preceding days+current day)
C Output arrays: SMED(0:72) for longitudes -180:5:180 (or SMED(0:23) for UT hours)
C                 STD1(0:72),STD2(0:72)
C
	DIMENSION CC(15,0:72),SMED(0:72),STD1(0:72),STD2(0:72)
	+,X1(15),X2(15)
		COMMON /BL1/CC,SMED,STD1,STD2
C "MEDIAN:"
       DO 1030 M=0,ncol
      MM=0
      DO N=1,ndnr
      X1(N)=CC(N,M)
      ENDDO 
  880 XX=0.
CREM MAX X1(N)
  890 DO N=1,ndnr
  900 IF (XX.lt.X1(N)) THEN 
      XX=X1(N)
	ENDIF
      ENDDO      !N
  920 IF (XX.eq.0) GOTO 980
C
  930 DO 960 N=1,ndnr
      IF (X1(N).lt.XX) GOTO 960
      MM=MM+1 
      X2(MM)=XX 
	X1(N)=0.
  960 CONTINUE      ! N
  970 IF (MM.lt.NDNR) GOTO 880
  980 XMM=FLOAT(MM)
      XD1=XMM/2.
      ND1=INT(XD1)
	CD1=FLOAT(ND1) 
      ND2=ND1+1 
      IF (CD1.LT.XD1) THEN 
	XMD=X2(ND2)
	else
	XMD=(X2(ND1)+X2(ND2))/2.
	ENDIF
C
      SMED(M)=XMD
C Standard deviation:
	sumneg=0.
	sumpos=0.
	icntpos=0
	icntneg=0
	do ii=1,ndnr
	if (x2(ii).gt.xmd) then
	sumpos=sumpos+(x2(ii)-xmd)**2
	icntpos=icntpos+1
	endif
	if (x2(ii).lt.xmd) then
	sumneg=sumneg+(x2(ii)-xmd)**2
	icntneg=icntneg+1
	endif
	enddo
	STD1(M)=0.0
	STD2(M)=0.0
	if (icntneg.gt.0) STD1(M)=sqrt(sumneg/icntneg)
	if (icntpos.gt.0) STD2(M)=sqrt(sumpos/icntpos)
	if (std1(m).eq.0.0) STD1(M)=STD2(M)
	if (std2(m).eq.0.0) STD2(M)=STD1(M)
 1030 CONTINUE
C 
c
 1050 RETURN
      END